<template>
  <div class="container">
    <h1>Notes</h1>
    <b-alert
      :show="dismissCountDown"
      dismissible
      :variant="message.color"
      @dismissed="dismissCountDown=0"
      @dismiss-count-down="countDownChanged"
    >
      <h3>{{ message.text }}</h3>
      <img src="https://2.bp.blogspot.com/-aVpbRn6VDqM/VCheHsw_C8I/AAAAAAAAAdU/JvhMM4HRtaM/s1600/Baile%2BFranky.gif" />
    </b-alert>
    <form class="container" @submit.prevent="add()">
      <h3>Add note</h3>
      <input type="text" class="form-control my-2" placeholder="Name" v-model="newNote.name">
      <input type="text" class="form-control my-2" placeholder="Description" v-model="newNote.description">
      <b-button class="btn-success my-2" type="submit" :disabled="newNote.name.length === 0 || newNote.description.length === 0">Add</b-button>
    </form>
    <table class="table container">
      <thead>
        <tr>
          <th scope="col">#</th>
          <th scope="col">Name</th>
          <th scope="col">description</th>
          <th scope="col">Alias</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(item, index) in notes" :key="index">
          <th scope="row">{{ item._id }}</th>
          <td>{{ item.name }}</td>
          <td>{{ item.description }}</td>
          <td>{{ item.alias }}</td>
          <td>
            <b-button @click="alert('success', 'SUCCESS')">Acción</b-button>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<script>
import AutoCloseAlert from '../components/autoCloseAlert'
import { mapActions, mapGetters } from 'vuex'
export default {
    components: {
        AutoCloseAlert
    },
    created () {
      this.getAllNotes()
    },
    data () {
        return {
          dismissSecs: 2.95,
          dismissCountDown: 0,
          message: {
            color: '',
            text: ''
          },
          newNote: {
            name: '',
            description: ''
          }
        }
    },
    methods: {
      ...mapActions({
        getAllNotes: 'getAllNotes',
        addNote: 'addNote'
      }),
      add () {
        this.addNote(this.newNote)
        .then(() => {
          this.alert('success', 'Note added successfulyy!')
          this.newNote.name = ''
          this.newNote.description = ''
        })
      },
      countDownChanged(dismissCountDown) {
        this.dismissCountDown = dismissCountDown
      },
      showAlert() {
        this.dismissCountDown = this.dismissSecs
      },
      alert(color, text) {
        this.message.color = color
        this.message.text = text
        console.log('message:', this.message)
        this.showAlert()
      }
    },
    computed: {
      ...mapGetters({
        notes: 'getAllNotes'
      })
    }
}
</script>